/* datastructures.h - Generic Datastructures header file
 * Copyright (C) 2001-2005 CryptNET, V. Alex Brennen (VAB)
 *
 * This file is part of the CryptNET OpenPGP Public Key Server (cks).
 *
 * cks is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * cks is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef DATASTRUCTURES
#define DATASTRUCTURES

#include <stdio.h>
#include <stdlib.h>

#include "cgi.h"
#include "cks_constants.h"


struct linked_list
{
	char *data;

	struct linked_list *next;
};

struct d_linked_list
{
	void *name;
	void *value;
	void *keyid;
	void *lkeyid;

	struct d_linked_list *prev;
	struct d_linked_list *next;
};

struct name_value_pair_dllst
{
	unsigned char *name;
	unsigned char *value;

	struct name_value_pair_dllst *prev;
	struct name_value_pair_dllst *next;
};

struct keys_to_sync
{
	unsigned char fp[41];

	struct keys_to_sync *next;
};

struct servers_to_sync
{
	unsigned char srvr[301];
	unsigned char email[301];

	struct servers_to_sync *prev;
	struct servers_to_sync *next;
};


/* d_linked_list */
struct d_linked_list * new_dll_node(void *, size_t, void *, size_t);
int add_dll_item(struct d_linked_list **, struct d_linked_list *);
struct d_linked_list * get_first_dll_node(struct d_linked_list *);
struct d_linked_list * get_last_dll_node(struct d_linked_list *);
void free_dll(struct d_linked_list **);
/* /d_linked_list */

struct name_value_pair_dllst* new_nvp_dll_node(void *, size_t, void *, size_t);
struct name_value_pair_dllst *get_first_pair(struct name_value_pair_dllst *);
struct name_value_pair_dllst *get_last_pair(struct name_value_pair_dllst *);
char *get_value(struct name_value_pair_dllst *,char *);

int add_dllst_item(struct name_value_pair_dllst **, struct name_value_pair_dllst *);
void free_name_value_pair_dllst(struct name_value_pair_dllst *);

/*
#define DEBUG
*/
#endif
